[DOI-image]: https://zenodo.org/badge/DOI/10.5281/zenodo.3235832.svg

[DOI]: https://doi.org/10.5281/zenodo.3235832

# XMC

[![DOI][DOI-image]][DOI]

**XMC** is a Python library for parallel, adaptive, hierarchical Monte Carlo algorithms, aiming at reliability, modularity, extensibility and high performance.

**XMC** is developed within the [ExaQUte](http://exaqute.eu/) European H2020 project.

**XMC** is **free** under BSD-4 license.

## Main features
The algorithms **XMC** can run include:
- Monte Carlo,
- Multilevel Monte Carlo,
- Continuation Multilevel Monte Carlo,
- Asynchronous Monte Carlo and Multilevel Monte Carlo.

## Documentation and usage
Documentation is still a work in progress. 
It can be found in the form of docstrings in the code and as HTML pages in `doc/html`. 
In particular, see `doc/html/start.html` for help in installing and configuring XMC.
If you do not wish to download these files manually, you may follow [this link](https://glcdn.githack.com/RiccardoRossi/exaqute-xmc/-/raw/be43a6c4ea8144a35bbbcf6b75201af1922dc604/doc/html/index.html) instead.
That link may be updated more slowly; the files in `doc/html` are the reference.

Some examples and validation benchmarks can be found [here](https://gitlab.com/RiccardoRossi/exaqute-xmc/-/tree/development/examples/).

## External collaborations
**XMC** is integrated with [Kratos Multiphysics](https://github.com/KratosMultiphysics/Kratos) as solver software.

## How to cite XMC?
All the necessary metadata, as well as formatted citations, are provided on the [Zenodo record](http://doi.org/10.5281/zenodo.3235832).
